﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using dotMath2;

namespace dotMath2Test
{
    /// <summary>
    /// Summary description for WhiteSpaceHandlerTests
    /// </summary>
    [TestClass]
    public class WhiteSpaceHandlerTests
    {
        public WhiteSpaceHandlerTests()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void WhiteSpaceHandler_HandleSpace()
        {
            string space = " ";
            WhitespaceHandler handler = new WhitespaceHandler();
            CharEnumerator enumerator = space.GetEnumerator();
            enumerator.MoveNext();
            Assert.AreEqual<bool>(true, handler.HandleCurrentCharacter(enumerator));
            
        }

        [TestMethod]
        public void WhiteSpaceHandler_HandleTab()
        {
            string space = "\t";
            WhitespaceHandler handler = new WhitespaceHandler();
            CharEnumerator enumerator = space.GetEnumerator();
            enumerator.MoveNext();
            Assert.AreEqual<bool>(true, handler.HandleCurrentCharacter(enumerator));
        }


        [TestMethod]
        public void WhiteSpaceHandler_NonWhiteSpace()
        {
            string space = "A";
            WhitespaceHandler handler = new WhitespaceHandler();
            CharEnumerator enumerator = space.GetEnumerator();
            enumerator.MoveNext();
            Assert.AreEqual<bool>(false, handler.HandleCurrentCharacter(enumerator));
        }
    }
}
